;Originally by Henrik Jnsson
;Rewritten by Paul Aurich
;translated in french by Julien Wallior

 include "os.h"
; include "graphlib.h"
 include "period89.h"			;Mostly offsets to data
 include "macros.h"			;A bunch of functions as macro's (to save space)
 xdef _nostub
 xdef _main
 xdef _exit
 xdef _comment
 
_main:
 movem.l	d0-a6,-(a7)
 lea	LCD_MEM,a0
 move.l	#959,d0
copyDisplay:
 move.l	(a0)+,-(a7)
 dbra	d0,copyDisplay
SpecialMain:
 bsr		DrawPeriodic					;Draw the cells (with elementy symbol and #)
MainLoop:
 WriteElementNameAtBottom
 bsr		MarkCell						;XOR (Invert) the current cell
 ROM_CALL ngetchx					;wait for a key press and store the key pressed in d0
 bsr		MarkCell						;XOR (Invert) the current cell

 cmp.w	#escKey,d0						;Was the Esc key pressed?
 beq		_exit							;if so, exit the program

 cmp.w	#enterKey,d0					;Was the Enter key pressed?
 bne		NotShowInfo						;if not, then don't show the info about the current element (branch ahead)
 ShowInfo
 bra		SpecialMain						;Re-draw cells and start main loop again

NotShowInfo:
 cmp.w	#appsKey,d0						;Was the Apps Key pressed
 beq		Main_Menu						;show the main menu

 move.l	(TableX),(OldTX)					;this backs up both the TableX & TableY

;Check arrow-pad relevant key combos
KeyLoop:
 cmp.w	#upKey,d0						;Was the up key pressed?
 bne		\NotUp
 subq.w	#1,(ActiveOffsY)					;if so, move the current cell up one w/o changing the cells displayed on the entire screen
\NotUp:
 cmp.w	#downKey,d0					;Was the down key pressed?
 bne		\NotDown
 addq.w	#1,(ActiveOffsY)					;if so, move the current cell down one w/o changing current cells displayed
\NotDown:
 cmp.w	#rightKey,d0					;Was the right key pressed?
 bne		\NotRight
 addq.w	#1,(ActiveOffsX)					;if so, move one cell to the right
\NotRight:
 cmp.w	#leftKey,d0					;Was the left key pressed?
 bne		\NotLeft
 subq.w	#1,(ActiveOffsX)					;if so, move cell one to left
\NotLeft:
 cmp.w    #upKey+4096,d0                    ;Was the 2nd-up key combo pressed?
 bne        \NotUp4Spaces
 move.w    #upKey,d0                        ;make it look like the up key was pressed (used for checking later)
 subq.w    #4,(ActiveOffsY)                    ;move the current cell up four
\NotUp4Spaces:
 cmp.w	#downKey+4096,d0					;Was the 2nd-down key combo pressed?
 bne		\NotDown4Spaces
 move.w	#downKey,d0					;change to only key down
 addq.w	#4,(ActiveOffsY)					;move the current cell down 4
\NotDown4Spaces:
 cmp.w	#leftKey+4096,d0					;Was the 2nd-left key combo pressed?
 bne		\NotLeft4Spaces
 move.w	#leftKey,d0					;change to key left
 subq.w	#4,(ActiveOffsX)					;move left 4 cells
\NotLeft4Spaces:
 cmp.w	#rightKey+4096,d0				
 bne		\NotRight4Spaces
 move.w	#rightKey,d0
 addq.w	#4,(ActiveOffsX)
\NotRight4Spaces:
 cmp.w	#diamondUp,d0
 bne		\NotToTop
 sub.w	#10,(ActiveOffsY)
\NotToTop:
 cmp.w	#diamondDown,d0
 bne		\NotToBottom
 add.w	#10,(ActiveOffsY)
\NotToBottom:
 cmp.w	#diamondRight,d0
 bne		\NotToRightSide
 add.w	#18,(ActiveOffsX)
\NotToRightSide:
 cmp.w	#diamondLeft,d0
 bne		\NotToLeftSide
 sub.w	#18,(ActiveOffsX)
\NotToLeftSide:
 move.w	(TableX),d1
 add.w	(ActiveOffsX),d1
 tst.w	d1
 bge		\NotTooFarLeft
 move.w	#rightKey,d0
 bra		KeyLoop
\NotTooFarLeft:
 cmp.w	#18,d1
 blt		\NotTooFarRight
 move.w	#leftKey,d0
 bra		KeyLoop
\NotTooFarRight:
 move.w	(ActiveOffsY),d1
 add.w	(TableY),d1
 tst.w	d1
 bge		\NotTooFarUp
 move.w	#downKey,d0
 bra		KeyLoop
\NotTooFarUp:
 cmp.w	#10,d1
 blt		\NotTooFarDown
 move.w	#upKey,d0
 bra		KeyLoop
\NotTooFarDown:
 lea		LookUpTable(pc),a0
 bsr		CalcCell
 tst.b	0(a0,d3)
 beq		KeyLoop
 
;Scroll the table?
TableMove:
 cmp.w	#2,(ActiveOffsX)
 bgt		\NotMoveTableLeft
 tst.w	(TableX)
 ble		\NotMoveTableLeft
 addq.w	#1,(ActiveOffsX)
 subq.w	#1,(TableX)
 bra		TableMove
\NotMoveTableLeft:
 cmp.w	#1,(ActiveOffsY)
 bgt		\NotMoveTableUp
 tst.w	(TableY)
 ble		\NotMoveTableUp
 addq.w	#1,(ActiveOffsY)
 subq.w	#1,(TableY)
 bra		TableMove
\NotMoveTableUp:
 cmp.w	#8,(ActiveOffsX)
 blt		\NotMoveTableRight
 cmp.w	#7,(TableX)
 bge		\NotMoveTableRight
 subq.w 	#1,(ActiveOffsX)
 addq.w	#1,(TableX)
 bra 		TableMove
\NotMoveTableRight:
 cmp.w	#4,(ActiveOffsY)
 blt		\NotMoveTableDown
 cmp.w	#4,(TableY)
 bge		\NotMoveTableDown
 subq.w 	#1,(ActiveOffsY)
 addq.w	#1,(TableY)
 bra 		TableMove
\NotMoveTableDown:
 move.w	(TableX),d7
 cmp.w	(OldTX),d7
 bne		SpecialMain
 move.w	(TableY),d7
 cmp.w	(OldTY),d7
 bne		SpecialMain
 bra		MainLoop


;****************** Main Menu ******************;
;This subroutine creates a menu with 4 choices: ;
;Browse names	Browse name of elements		;
;Browse symb.	Browse symbols of elements	;
;Menus:Medium	Dynamic. Controls speed of	;
;				scaling up			;
;Quit			Quits the program			;				
;								;
;Things to consider:					;
;	Make this a macro in next version?		;
;***********************************************;
Main_Menu:
 pea		Menu1Shortcuts(pc)
 pea		Menu1(pc)
 bsr		Menu
 addq.l	#8,a7

; cmp.w	#9999,(cnum)
 cmp.b	#$FF,(cnum)		;Pressed escape
 beq		SpecialMain

 cmp.b	#2,(cnum)
 beq		ChangeMenuDelaySpeed

 cmp.b	#3,(cnum)
 beq		_exit

 bsr		DrawPeriodic

 cmp.b	#1,(cnum)
 beq		BrowseSymbols1
\BrowseNames1:
 BrowseNames							;Selected item returned as (cnum)
 cmp.b	#$FF,(cnum)
 beq		SpecialMain						;If so, draw periodic and return to main menu
 lea		Menu2Sort(pc),a0					;Load a table which contains the # of the selcted element from (cnum)
 bra		CenterandRedraw					;Saves space by calling same commands only once for this and BrowseSymbols functions
BrowseSymbols1:
 BrowseSymbols
 cmp.b	#$FF,(cnum)
 beq		SpecialMain
 lea		Menu3Sort(pc),a0
CenterandRedraw:
 CenterOnElement
 bra		SpecialMain


;*********** Change Menu Delay Speed ***********;
;Subroutine of the Main Menu. Changes speed of	;
;the scale-up routine. Higher MenuDelay = slower;
;Output:None						;
;***********************************************;
ChangeMenuDelaySpeed:
 lea		Menu1(pc),a0
 cmp.w	#5000,(MenuDelay)
 beq		\Medium
 cmp.w	#10000,(MenuDelay)
 beq		\Slow
 move.w	#10000,(MenuDelay)
 lea		Slow(pc),a1
 bra		ChangeTxt
\Medium:
 clr.w	(MenuDelay)
 lea		Fast(pc),a1
 bra		ChangeTxt
\Slow:
 move.w	#5000,(MenuDelay)
 lea		Medium(pc),a1
ChangeTxt:
 adda.l	#54,a0
 moveq	#5,d0
\ChangeTxtLoop:
 move.b	(a1)+,(a0)+
 dbra		d0,\ChangeTxtLoop
 bsr		DrawPeriodic
 bra		Main_Menu


;****************** Calc Cell ******************;
;Calculates cell offset number of current cell	;
;Input:None							;
;Output:d3 = cell number (0-179)			;
;***********************************************;
CalcCell:
 move.w	(TableY),d3
 add.w	(ActiveOffsY),d3
 mulu		#18,d3
 add.w	(TableX),d3
 add.w	(ActiveOffsX),d3
 rts


;************** Calc Cell Special **************;
;A special version of CalcCell that calculates	;
;the periodic number of the selected cell		;
;Input:None.						;
;Output:d0 = Periodic Number				;
;	  d3 = Offset to the data in TheData	;
;***********************************************;
CalcCellSpecial:
 bsr		CalcCell
 lea		LookUpTable(pc),a0
 clr.w	d0
 move.b	0(a0,d3),d0
 move.w	d0,d3
 subq.w	#1,d3
 mulu		#DataOffset,d3
 rts


;**************** Draw Periodic ****************;
;Draws the periodic table including element	;
;numbers and symbols					;
;Input:None							;
;Output:None						;
;***********************************************;
DrawPeriodic:
 ROM_CALL ScreenClear
 bsr		SetFontSmall
 move.w	(TableY),d2
 add.w	#5,d2
 mulu		#18,d2
 add.w	(TableX),d2					;d2 now contains the cell # of
 add.w	#10,d2					;the lower right item on the screen
 moveq	#5,d1						;y-cell offset
\YLoop:
 moveq	#10,d0					;x-cell offset
\XLoop:
 lea		LookUpTable(pc),a0
 clr.l	d7
 move.b	0(a0,d2),d7
 tst.b	d7
 beq		\BlankCell
 move.w	d0,d3						;x @ the top-left corner
 mulu		#14,d3
 addq.w	#3,d3
 move.w	d1,d4						;y @ the top-left corner
 mulu		#14,d4
 addq.w	#6,d4
 move.w	d3,d5						;x @ the bottom-right corner
 add.w	#14,d5
 move.w	d4,d6						;y @ the bottom-irght
 add.w	#14,d6
; movem.w	d6-d3,-(a7)					;smaller than 4 seperate pushes
; graphlib::frame_rect
; addq.l	#8,a7
 movem.l	d0-d2/a0,-(a7)
 bsr	DrawFrame
;Write Name of Element
 move.w	d7,d5
 subq.w	#1,d5
 mulu		#DataOffset,d5
 addq.w	#1,d3
 addq.w	#2,d4
 lea		TheData(pc),a0
 move.w	#4,-(a7)
 pea		0(a0,d5)
 move.w	d4,-(a7)					;y
 move.w	d3,-(a7)					;x
 ROM_CALL DrawStr
 addq.l	#8,a7
;Write Element Number
 clr.l	d0
 move.w	d7,d0
 clr.b	d1
 lea		tmpstring(pc),a0
 bsr		NumToStr 
 addq.w	#6,d4
 pea		(a0)
 move.w	d4,-(a7)
 move.w	d3,-(a7)
 ROM_CALL DrawStr
 lea		10(a7),a7
 movem.l	(a7)+,d0-d2/a0
\BlankCell:
 subq.w	#1,d2
 dbra		d0,\XLoop
 subq.w	#7,d2
 dbra		d1,\YLoop
 move.w	#4,-(a7)
 pea		title_text(pc)
 clr.w	-(a7)						;y
 clr.w	-(a7)						;x
 ROM_CALL DrawStr
 lea		10(a7),a7
 rts


;****************** Mark Cell ******************;
;Inverts the current cell (either making it	;
;black-on-white to indicate not selected cell	;
;or white-on-black to indicate selected cell.	;
;Input:None							;
;***********************************************;
MarkCell:
 move.w	d0,-(a7)					;Push d0 onto the stack to retain what it contains (the key pressed)
 move.w	(ActiveOffsX),d0				;Move ActiveOffsX into d0
 mulu		#14,d0					;Multiply it by the width of a cell (14)
 addq.w	#4,d0						;Add 4 so that d0 = x pixel-coord of top left corner of cur cell
 move.w	(ActiveOffsY),d1				;Move ActiveOffsY into d1
 mulu		#14,d1					;Multiply it by the heigth of a cell (14)
 addq.w	#7,d1						;Add y so that d1 = y pixel-coord of above-mentioned cell

 moveq	#12,d2					;12 pixels wide
 moveq	#12,d3					;12 pixels high
 clr.w	d4						;Video invert
 bsr		fill				;Invert the square that goes from (d0,d1) to (d0+12,d1+12)
 move.w	(a7)+,d0					;Recover the key pressed
 rts


;***************** NumberToStr *****************;
;Converts a floating-point number to a string	;
;Input: d0.l = Number					;
;	  d1.b = Comma pos (from right side)	;
;		ex: 12.3133 -> d1.b = 4			;
;		ex: d1 = 0  -> No comma			;
;	  a0 = pointer to a 10+1 byte string	;
;		ex: "          ",0			;
;Output:a0 = pointer to a 10+1 byte string	;
;		containing number				;
;***********************************************;
NumToStr:
 movem.l	d0-d5,-(a7)
 moveq	#1,d5
 adda.l	#10,a0					;a0 points to the last character of the string
 clr.b 	(a0)						;the last character is a null char
 move.l	d0,d3						;copy the Number to d3
 divu		#10000,d3					;Divide the number by 10000. Remainder is in upper 16 bits
 tst.w	d3
 beq		SkipExtra
 moveq	#1,d5
 clr.l	d4
 move.w	d3,d4
 mulu		#10000,d3
 move.l	d0,d2
 sub.l	d3,d2
 move.l	d2,d0
 bsr		NumToStrSub
 move.l	d4,d0
 subq.b	#4,d1
SkipExtra:
 clr.b	d5
 bsr		NumToStrSub
 movem.l	(a7)+,d0-d5
 rts
 
NumToStrSub:
 clr.b	d3
ConvLoop:
 addq.b	#1,d3
 divu		#10,d0
 move.l	d0,d2
 swap		d2
 add.b	#48,d2
 move.b	d2,-(a0)
 cmp.b	d1,d3
 bne		SkipComma
 move.b	#46,-(a0)
SkipComma:
 and.l	#$FFFF,d0
 tst.b	d5
 beq		Norm
 cmp.b	#4,d3
 bne		ConvLoop
 bra		EndNum
Norm:
 tst.l	d0
 bne		ConvLoop
EndNum:
 rts


;****************** Put Scale ******************;
;PutScale puts a image into the target part of	;
;video memory while scaling it from tiny to	;
;full size.							;
;Input (pushed onto stack in reverse order:	;
;PutScale(source y, target y, video mem off)	;
;***********************************************;
PutScale:
 movem.l	d0-d5/a0-a2,-(a7)
 move.l	44(a7),d0					;offset in video mem
 lea		LCD_MEM,a0
 adda.l	d0,a0						;byte offset
 moveq	#9,d5						;size-x
 move.w	42(a7),d1					;size-y target
 subq.w	#1,d1
 clr.l	d2
 move.w	40(a7),d2					;size-y source
 
 lsl.w	#8,d2
 divu		d1,d2						;d2=stepy
 
 lea		LCD_MEM+20,a2				;original pointer to source

 clr.l	d3						;start
 
YLoopScale:
 move.w	d3,d4
 lsr.w	#8,d4
 mulu		#30,d4
 lea		0(a2,d4),a1					;source

 move.w	d5,d0
 
XLoopScale:
 move.b	0(a1,d0),0(a0,d0)
 dbra		d0,XLoopScale
 adda.l	#30,a0
 add.w	d2,d3
 dbra		d1,YLoopScale
 movem.l	(a7)+,d0-d5/a0-a2
 rts

;****** Scale Up Animation *******
ScaleUp:
 moveq	#2,d6
ScaleRepeat:
 move.w	(MenuDelay),d7
PauseLoop:
 dbra		d7,PauseLoop
 
 ; Calculate offset:
 clr.l	d4
 move.w	(yoffs),d4
 add.w	#40,d4
 move.w	d6,d5
 lsr.w	#1,d5
 sub.w	d5,d4
 mulu		#30,d4

 move.w	(xoffs),d5
 lsr.w	#3,d5
 add.w	d5,d4

 move.l	d4,-(a7)					;dest. offset
 move.w	d6,-(a7)					;dest. size y
 move.w	#81,-(a7)					;source size y
 bsr		PutScale
 addq.l	#8,a7
 
 add.w	#1,d6
 cmp.w	#82,d6
 bne		ScaleRepeat
 rts


;******************** Menu *********************;
;Draws a menu and then scrolls it until the	;
;enter key is pressed.					;
;Input pushed onto stack in reverse order:	;
;       * to shortcut table, * to table		;
;		* means pointer				;
;Output:(cnum).w = selected item			;
;		cnum=$FF if ESC pressed		;
;***********************************************;
Menu:
 movem.l	d0-d7/a0-a4,-(a7)
 movea.l	56(a7),a4					;a4 points to table
 move.b	(a4)+,(maxnum)				;# of rows
 movea.l	60(a7),a3					;a3 points to shortcut table
 clr.b	(cnum)
 clr.w	(yoffs)
 move.w	#160,(xoffs)
 bsr	DrawBack
 adda.l	#20,a4	
 move.b	(a4)+,(width)				;width of entries
 bsr	Draw_Menu
 move.w	#161,d0
 moveq	#40,d1
 moveq	#1,d2
 moveq	#7,d3
 moveq	#2,d4
 bsr		fill
 cmp.b	#3,(width)
 bne		\FillSmallerArea
 move.w	#175,d0
 moveq	#63,d2
 bsr		fill
\FillSmallerArea:
 move.w	#235,d0
 moveq	#3,d2
 bsr		fill

 move.w	#$0028,(xoffs)
 bsr		ScaleUp
 
;... end remove

 move.b	#$FF,(Oldcn)
RepeatMenu:
 move.b	(cnum),d0
 sub.b	d0,(Oldcn)
 tst.b	(Oldcn)
 beq		\SkipRedraw
 bsr		Draw_Menu
\SkipRedraw:
 ROM_CALL ngetchx
 cmp.w	#escKey,d0			;esc key
 beq		DoneMenu
 cmp.w	#enterKey,d0		;enter key
 beq		DoneMenu

 move.b	(cnum),d1
 move.b	(cnum),(Oldcn)
 move.b	(maxnum),d2
 subq.b	#1,d2

 cmp.w	#upKey,d0			;up key
 bne		NotUp
 tst.w	d1
 ble		NotUp
 subq.b	#1,(cnum)
NotUp:
 cmp.w	#downKey,d0		;down key
 bne		NotDown
 cmp.b	d2,d1
 bge		NotDown
 addq.b	#1,(cnum)
NotDown:
 cmp.w	#upKey+4096,d0		;up 9 (2ND + KEY_UP)
 bne		NotUp2
 sub.b	#9,(cnum)
 tst.b	cnum
 bge		NotUp2
 clr.b	(cnum)
NotUp2:
 cmp.w	#downKey+4096,d0		;down 9 (2ND + KEY_DOWN)
 bne		NotDown2
 add.b	#9,(cnum)
 move.b	(cnum),d1
 cmp.b		d2,d1
 ble		NotDown2
 move.b	d2,(cnum)
NotDown2
 cmp.w	#diamondUp,d0		;up to top (diamond + KEY_UP)
 bne		NotTop
 clr.b	(cnum)
NotTop:
 cmp.w	#diamondDown,d0		;down to bottom (diamond + KEY_DOWN)
 bne		NotBottom
 move.b	d2,(cnum)
NotBottom:
 cmp.w	#97,d0			;the letter a
 blt		NotShortCut
 cmp.w	#122,d0			;the letter z
 bgt		NotShortCut
 sub.w	#97,d0
; lsl.w	#1,d0
; clr.w	d1
; move.b	0(a3,d0),d1
 move.b	0(a3,d0),(cnum)

NotShortCut:
 bra		RepeatMenu
DoneMenu:
 cmp.w	#enterKey,d0		;the enter key
 beq		Return
 move.b	#$FF,(cnum)		;Esc-quit
Return:
 movem.l	(a7)+,d0-d7/a0-a4
 rts


;****************** Draw Back ******************;
;Draws a white rectangle with black borders and ;
;writes the title (input)				;
;Input:a4 = pointer to title				;
;Ouput:None							;
;***********************************************;
DrawBack:
;Write Title
 bsr	SetFontSmall
 move.w	#4,-(a7)
 move.l	a4,-(a7)
 move.w	(yoffs),d4
 addq.w	#2,d4 
 move.w	d4,-(a7)					;y
 move.w	(xoffs),d4
 addq.w	#2,d4
 move.w	d4,-(a7)					;x
 ROM_CALL DrawStr 
 lea		10(a7),a7
 bsr		SetFontNormal
 move.w	(xoffs),d3
 move.w	(yoffs),d4
 move.w	d3,d5
 move.w d4,d6
 add.w	#79,d5
 add.w	#80,d6
 bsr	DrawFrame
 rts


;****************** Draw Menu ******************;
;An internal function of Menu. Draws the text in;
;the frame. DO NOT CALL ON OWN. CALL MENU!	;
;***********************************************;
Draw_Menu:
 movem.l	d0-d7/a0/a2/a4,-(a7)
 lea		LCD_MEM,a0
 clr.l	d3
 moveq	#8,d4
 move.b	(cnum),d3
 subq.b	#5,d3
DispLoop:
 addq.b	#1,d3
 tst.b	d3
 blt		Skip
 cmp.b	(maxnum),d3
 bge		Skip
 move.l	d3,d5
 bra		NoSkip
Skip:
 move.b	(maxnum),d5
NoSkip:
 clr.w	d0
 move.b	(width),d0
 mulu		d0,d5
 movea.l	a4,a2
 adda.l	d5,a2
 cmp.b	(cnum),d3
 bne		\NotSpecialColor
 clr.w	-(a7)
 bra		\DoneSpecialColor
\NotSpecialColor:
 move.w	#4,-(a7)
\DoneSpecialColor:
 move.l	a2,-(a7)
 
 move.w	d4,d5
 mulu	#8,d5
 move.w	(yoffs),d6
 add.w	#72,d6
 sub.w	d5,d6
 	
 move.w	d6,-(a7)					;y
 move.w	(xoffs),d5
 addq.w	#3,d5
 move.w	d5,-(a7)					;x
 ROM_CALL DrawStr 
 lea		10(a7),a7
 dbra		d4,DispLoop

 movem.l	(a7)+,d0-d7/a0/a2/a4
 rts

;Exit routine
_exit:
 tst.w	handle1num					;tests if handle was allocated when the crash occurred
 beq		\notalloc
 move.w	(handle1num),-(a7)
 ROM_CALL HeapFree				;Frees the memory
 addq.l	#2,a7
\notalloc: 
 lea	LCD_MEM+3840,a0
 move.l	#959,d0
\copyDisplay:
 move.l	(a7)+,-(a0)
 dbra	d0,\copyDisplay
 movem.l	(a7)+,d0-a6
 rts								;Return to the TI-OS


SetFontSmall:						;Set the font to small size
 clr.w	-(a7)						;Push a 0 onto the stack
 bra		SetFont					;Saves a little space
SetFontNormal:						;Set the font to normal size
 move.w	#1,-(a7)					;Push a 1 onto the stack
SetFont:
 ROM_CALL FontSetSys			;Set the font to whatever is the first word on the stack
 addq.w	#2,a7						;Add 2 to the stack pointer
 rts								;Return from the subroutine

DrawFrame:
;d3 = x1
;d4 = y1
;d5 = x2
;d6 = y2
;void DrawLine (int x0, int y0, int x1, int y1, int Attr);
 move.w #1,-(a7)
 move.w d4,-(a7)
 move.w d5,-(a7)
 move.w d4,-(a7)
 move.w d3,-(a7)
 ROM_CALL DrawLine
 move.w	d6,2(a7)
 move.w	d5,(a7)
 ROM_CALL DrawLine
 move.w	d6,6(a7)
 move.w	d3,4(a7)
 ROM_CALL DrawLine
 move.w	d4,2(a7)
 move.w	d3,(a7)
 ROM_CALL DrawLine
 lea	10(a7),a7
 rts
 
;All credit for these functions (fill, horiz, and prepare) goes to whoever wrote the Doors Graphlib (the doors team, i think)
fill:
	movem.l	d0-d7/a0-a6,-(a7)	; save registers
	exg.w		d4,d3			;  d3 in d4 and d4 in d3 because of horiz: color in d3
	add.w		d0,d2			;  width + x1=x2
\line	bsr		horiz			;  disp the line x1,y1,x2,y1
	addq.w		#1,d1			;+1 to y1
	dbra		d4,\line		;make a loop d4 (height) time
	movem.l	(a7)+,d0-d7/a0-a6	;restore registers
 	rts 					;quit func
horiz:
	movem.l		d0-d7/a0-a6,-(a7)
	cmp.w		d0,d2
	bge		\coolhr			; if d2 greater than d1go to coolhr
	exg.w		d0,d2			; if d1 greater
\coolhr
	bsr		prepare
	sub.w		d0,d2 			;d2:width of the line
	addq.w		#1,d2
\set	bchg		d4,(a1)			 ;inverse the bit d4 of the byte at a1
	tst.w		d3
	beq		\pixdone			; if color= inverse:next pixel
	bclr		d4,(a1)			;clear the bit d4 of the byte at a1
	cmp.w		#1,d3;
	beq		\pixdone			;if color= white:nextpixel
	bset		d4,(a1)			;else: sets the bit
\pixdone subq.w		#1,d2
	tst.b		d4			; if it is the last bit:76543210
	beq		\bytes
	subq.w		#1,d4			;else: next bit
\test	tst.w		d2			;d2=number of pixels to plot
	bne		\set
	movem.l		(a7)+,d0-d7/a0-a6
	rts
\bytes
 	addq.l		#1,a1			;a1: address of the next byte
	cmp.w		#8,d2			; if d2 is less or equal than 7, it remains one byte:go to finb
	blt		\finb			;else plot the whole byte
	not.b		(a1)			;inverse 
	tst.w		d3			;if color= inverse:OK
	beq		\lndone
	clr.b		(a1);
	cmp.w		#1,d3			;if color=white:OK
	beq		\lndone
	not.b		(a1)		
\lndone subq.w	#7,d2
	dbra		d2,\bytes		;d2-8
\finb	moveq.b	#7,d4			; d4= bit that correspond to the pixel in a byte:7:first bit
	bra		\test
	
prepare:
	move.w		d0,d4
	move.w		d1,d5
	lea		$4c00,a1			; a1:right address of the screen
	mulu.w		#30,d1			; a horiz line:240=30*8 pixels: 30 bytes
	add.l		d1,a1			;a1: address of the start of line d1
	lsr.w		#3,d4; d4=width/8  
	add.w		d4,a1			; a1:address of the bytes which contains the pixel
	move.w		d0,d4       		;    for example:          d0:00010101
	not.b		d4			;                                 d4:11101010
	and.b		#7,d4			;          #7:00000111  d4:00000010
						; d4= bit that correspond to the pixel in a byte:
	rts					;              76543210

 even

;**************** Vars And Data ****************;
;These are variables used in the program. Some  ;
;'variables', including DataOffset, are defined ;
;as static equates in period89.h. Look there if    ;
;it's not here.                    ;
;***********************************************;
MenuDelay        dc.w    5000                ;The delay during scaling-up of a menu. Higher = slower
Oldcn            dc.b    0                ;The old cnum. Used to reduce flicker in menu routine
cnum            dc.b    0                ;The currently selected element in a menu. Used to return a
                                ;value to the rest of the program telling which item was selected
maxnum        dc.b    0                ;The last item on the list. Used so that user doesn't scroll
                                ;off the end of a list.
xoffs            dc.w    0                ;xoffs and yoffs are used to draw rectangles on the screen in
yoffs            dc.w    0                ;different places using the same routine.
width            dc.b    0    
TableX        dc.w    3                ;X coordinate of upper left element on screen
TableY        dc.w    1                ;Y coordinate of upper left element on screen
OldTX            dc.w    0                ;OldTX & OldTY are used to decide whether the user has
OldTY            dc.w    0                ;scrolled the table and if it needs to be redrawn
ActiveOffsX     dc.w    4                ;X coordinate offset to selected element from top left
ActiveOffsY     dc.w    2                ;Y coordinate offset to selected element from top left
handle1num        dc.w    0                ;A handle for allocated memory. Used in Browse Symbols and Browse Names

;---------------------------------------------
; Structure of TheData:
; Offset    Length        Identifier
; 0        3            *Symbol
; 3        13            *Name
; 16        5            *Mass (Word+Byte comma)
; 21        4            Electron Config.
; 25        1            Element type
; 26        1            *1st Ionization energy (eV)
; 27        1            *Electronegativity
; 28        1            Pos. Oxidation states
; 29        1            Neg. Oxidation states
; 30        2            *Melting Point
; 32        2            *Boiling Point
; 34        1            *Melting Point Comma
; 35        1            *Boiling Point Comma
;---------------------------------------------
; Total Size: 36 bytes / element
;Mass, boiling point, and melting point taken from http://www.chemicalelements.com/
;First ionization, electronegativity taken from http://ptoe.move.to/
 
TheData:
 dc.b    "H ",0,"Hydrogene   ",0
 dc.l    100794        ;mass
 dc.b    5            ; mass-comma
 dc.b    1,0,0,0
 dc.b    1
 dc.b    136
 dc.b    21
 dc.b    %00000001
 dc.b    %00000001
 dc.w    14010
 dc.w    20280
 dc.b    3
 dc.b    3
 dc.b    "He",0,"Helium      ",0
 dc.l    4002602        ; mass
 dc.b    6            ; mass-comma
 dc.b   2,0,0,0
 dc.b    7
 dc.b    246
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    11500
 dc.w    45500
 dc.b    4
 dc.b    4
 dc.b    "Li",0,"Lithium     ",0
 dc.l    6941          ; mass
 dc.b    3            ; mass-comma
 dc.b   1,0,0,0
 dc.b    2
 dc.b    54
 dc.b    10
 dc.b    %00000001
 dc.b    %00000000
 dc.w    45369
 dc.w    16202
 dc.b    2
 dc.b    1
 dc.b    "Be",0,"Beryllium   ",0
 dc.l    9012182        ; mass
 dc.b    6            ; mass-comma
 dc.b   2,0,0,0
 dc.b    3
 dc.b    93
 dc.b    15
 dc.b    %00000010
 dc.b    %00000000
 dc.w    15512
 dc.w    32432
 dc.b    1
 dc.b    1
 dc.b    "B ",0,"Bore        ",0
 dc.l    10811          ; mass
 dc.b    3            ; mass-comma
 dc.b   2,1,0,0
 dc.b    6
 dc.b    83
 dc.b    20
 dc.b    %00000100
 dc.b    %00000000
 dc.w    25732
 dc.w    28322
 dc.b    1
 dc.b    1
 dc.b    "C ",0,"Carbone     ",0
 dc.l    120107        ; mass
 dc.b    4            ; mass-comma
 dc.b   2,2,0,0
 dc.b    1
 dc.b    113
 dc.b    25
 dc.b    %00001010
 dc.b    %00001000
 dc.w    37732
 dc.w    51002
 dc.b    1
 dc.b    1
 dc.b    "N ",0,"Azote       ",0
 dc.l    1400674        ; mass
 dc.b    5            ; mass-comma
 dc.b   2,3,0,0
 dc.b    1
 dc.b    145
 dc.b    30
 dc.b    %00011111
 dc.b    %00000111
 dc.w    63250
 dc.w    7735
 dc.b    3
 dc.b    2
 dc.b    "O ",0,"Oxygene     ",0
 dc.l    159994        ; mass
 dc.b    4            ; mass-comma
 dc.b   2,4,0,0
 dc.b    1
 dc.b    136
 dc.b    35
 dc.b    %00000000
 dc.b    %00000010
 dc.w    54750
 dc.w    9015
 dc.b    3
 dc.b    2
 dc.b    "F ",0,"Fluor       ",0
 dc.l    18998404    ; mass
 dc.b    6            ; mass-comma
 dc.b   2,5,0,0
 dc.b    1
 dc.b    174
 dc.b    40
 dc.b    %00000000
 dc.b    %00000001
 dc.w    53530
 dc.w    8501
 dc.b    3
 dc.b    2
 dc.b    "Ne",0,"Neon        ",0
 dc.l    201797         ; mass
 dc.b    4            ; mass-comma
 dc.b   2,6,0,0
 dc.b    7
 dc.b    216
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    24550
 dc.w    27050
 dc.b    3
 dc.b    3
 dc.b    "Na",0,"Sodium      ",0
 dc.l    2298977        ; mass
 dc.b    5            ; mass-comma
 dc.b   1,0,0,0
 dc.b    2
 dc.b    51
 dc.b    9
 dc.b    %00000001
 dc.b    %00000000
 dc.w    37095
 dc.w    8261
 dc.b    2
 dc.b    1
 dc.b    "Mg",0,"Magnesium   ",0
 dc.l    24305         ; mass
 dc.b    3            ; mass-comma
 dc.b   2,0,0,0
 dc.b    3
 dc.b    76
 dc.b    12
 dc.b    %00000010
 dc.b    %00000000
 dc.w    9232
 dc.w    13802
 dc.b    1
 dc.b    1
 dc.b    "Al",0,"Aluminium   ",0
 dc.l    2698139        ; mass
 dc.b    5            ; mass-comma
 dc.b   2,1,0,0
 dc.b    5
 dc.b    60
 dc.b    15
 dc.b    %00000100
 dc.b    %00000000
 dc.w    9335
 dc.w    27402
 dc.b    1
 dc.b    1
 dc.b    "Si",0,"Silicium    ",0
 dc.l    280855        ; mass
 dc.b    4            ; mass-comma
 dc.b   2,2,0,0
 dc.b    6
 dc.b    81
 dc.b    18
 dc.b    %00001010
 dc.b    %00001000
 dc.w    16832
 dc.w    26282
 dc.b    1
 dc.b    1
 dc.b    "P ",0,"Phosphore   ",0
 dc.l    3097376        ; mass
 dc.b    5            ; mass-comma
 dc.b   2,3,0,0
 dc.b    1
 dc.b    110
 dc.b    21
 dc.b    %00010100
 dc.b    %00000100
 dc.w    31725
 dc.w    55315
 dc.b    2
 dc.b    2
 dc.b    "S ",0,"Soufre      ",0
 dc.l    32066          ; mass
 dc.b    3            ; mass-comma
 dc.b   2,4,0,0
 dc.b    1
 dc.b    104
 dc.b    25
 dc.b    %00101000
 dc.b    %00000010
 dc.w    38595
 dc.w    7178
 dc.b    2
 dc.b    1
 dc.b    "Cl",0,"Chlore      ",0
 dc.l    354527         ; mass
 dc.b    4            ; mass-comma
 dc.b   2,5,0,0
 dc.b    1
 dc.b    130
 dc.b    30
 dc.b    %01010101
 dc.b    %00000001
 dc.w    17217
 dc.w    23855
 dc.b    2
 dc.b    2
 dc.b    "Ar",0,"Argon       ",0
 dc.l    39948         ; mass
 dc.b    3            ; mass-comma
 dc.b   2,6,0,0
 dc.b    7
 dc.b    158
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    8385
 dc.w    8715
 dc.b 2
 dc.b    2
 dc.b    "K ",0,"Potassium   ",0
 dc.l    390983        ; mass
 dc.b    4            ; mass-comma
 dc.b   1,0,0,0
 dc.b    2
 dc.b    43
 dc.b    8
 dc.b    %00000001
 dc.b    %00000000
 dc.w    33680
 dc.w    10472
 dc.b    2
 dc.b    1
 dc.b    "Ca",0,"Calcium     ",0
 dc.l    40078          ; mass
 dc.b    3            ; mass-comma
 dc.b   2,0,0,0
 dc.b    3
 dc.b    61
 dc.b    10
 dc.b    %00000010
 dc.b    %00000000
 dc.w    11122
 dc.w    17572
 dc.b    1
 dc.b    1
 dc.b    "Sc",0,"Scandium    ",0
 dc.l    4495591        ; mass
 dc.b    5            ; mass-comma
 dc.b   2,1,0,0
 dc.b    4
 dc.b    66
 dc.b    13
 dc.b    %00000100
 dc.b    %00000000
 dc.w    18122
 dc.w    31052
 dc.b    1
 dc.b    1
 dc.b    "Ti",0,"Titane      ",0
 dc.l    47867          ; mass
 dc.b    3            ; mass-comma
 dc.b   2,2,0,0
 dc.b    4
 dc.b    68
 dc.b    15
 dc.b    %00001110
 dc.b    %00000000
 dc.w    19332
 dc.w    35602
 dc.b    1
 dc.b    1
 dc.b    "V ",0,"Vanadium    ",0
 dc.l    509415        ; mass
 dc.b    4            ; mass-comma
 dc.b   2,3,0,0
 dc.b    4
 dc.b    67
 dc.b    16
 dc.b    %00011110
 dc.b    %00000000
 dc.w    21632
 dc.w    36532
 dc.b    1
 dc.b    1
 dc.b    "Cr",0,"Chrome      ",0
 dc.l    519961         ; mass
 dc.b    4            ; mass-comma
 dc.b   1,5,0,0
 dc.b    4
 dc.b    68
 dc.b    16
 dc.b    %00100110
 dc.b    %00000000
 dc.w    21302
 dc.w    29452
 dc.b    1
 dc.b    1
 dc.b   "Mn",0,"Manganese   ",0
 dc.l    5493805
 dc.b    5
 dc.b   2,5,0,0
 dc.b    4
 dc.b    74
 dc.b    15
 dc.b    %01001110
 dc.b    %00000000
 dc.w    15182
 dc.w    22352
 dc.b    1
 dc.b    1
 dc.b   "Fe",0,"Fer         ",0
 dc.l    55845
 dc.b    3
 dc.b   2,6,0,0
 dc.b    4
 dc.b    79
 dc.b    18
 dc.b    %00000110
 dc.b    %00000000
 dc.w    18082
 dc.w    30232
 dc.b    1
 dc.b    1
 dc.b   "Co",0,"Cobalt      ",0
 dc.l    589332
 dc.b    4
 dc.b   2,7,0,0
 dc.b    4
 dc.b    79
 dc.b    18
 dc.b    %00000110
 dc.b    %00000000
 dc.w    17682
 dc.w    31432
 dc.b    1
 dc.b    1
 dc.b   "Ni",0,"Nickel      ",0
 dc.l    586934
 dc.b    4
 dc.b   2,8,0,0   
 dc.b    4
 dc.b    76
 dc.b    18
 dc.b    %00000110
 dc.b    %00000000
 dc.w    17262
 dc.w    30052
 dc.b    1
 dc.b    1
 dc.b   "Cu",0,"Cuivre      ",0
 dc.l    63546
 dc.b    3
 dc.b   1,10,0,0
 dc.b    4
 dc.b    77
 dc.b    19
 dc.b    %00000011
 dc.b    %00000000
 dc.w    13562
 dc.w    28402
 dc.b    1
 dc.b    1
 dc.b   "Zn",0,"Zinc        ",0
 dc.l    6539
 dc.b    2
 dc.b   2,10,0,0
 dc.b    5
 dc.b    94
 dc.b    16
 dc.b    %00000010
 dc.b    %00000000
 dc.w    6927
 dc.w    11802
 dc.b    1
 dc.b    1
 dc.b   "Ga",0,"Gallium     ",0
 dc.l    69723
 dc.b    3
 dc.b   2,10,1,0
 dc.b    5
 dc.b    60
 dc.b    16
 dc.b    %00000100
 dc.b    %00000000
 dc.w    30293
 dc.w    26762
 dc.b    2
 dc.b    1
 dc.b   "Ge",0,"Germanium   ",0
 dc.l    7261
 dc.b    2
 dc.b   2,10,2,0
 dc.b    6
 dc.b    79
 dc.b    18
 dc.b    %00001010
 dc.b    %00000000
 dc.w    12106
 dc.w    31032
 dc.b    1
 dc.b    1
 dc.b   "As",0,"Arsenic     ",0
 dc.l    749216
 dc.b    4
 dc.b   2,10,3,0
 dc.b    6
 dc.b    98
 dc.b    20
 dc.b    %00010100
 dc.b    %00000100
 dc.w    10902
 dc.w    8862
 dc.b    1
 dc.b    1
 dc.b   "Se",0,"Selenium    ",0
 dc.l    7896
 dc.b    2
 dc.b   2,10,4,0
 dc.b    1
 dc.b    98
 dc.b    24
 dc.b    %00101000
 dc.b    %00000010
 dc.w    49015
 dc.w    9581
 dc.b    2
 dc.b    1
 dc.b   "Br",0,"Brome       ",0
 dc.l    79904
 dc.b    3
 dc.b   2,10,5,0
 dc.b    1
 dc.b    118
 dc.b    28
 dc.b    %00010001
 dc.b    %00000001
 dc.w    26595
 dc.w    33193
 dc.b    2
 dc.b    2
 dc.b   "Kr",0,"Krypton     ",0
 dc.l    838
 dc.b    1
 dc.b   2,10,6,0
 dc.b    7
 dc.b    140
 dc.b    0
 dc.b    %00000010
 dc.b    %00000000
 dc.w    11595
 dc.w    11975
 dc.b    2
 dc.b    2
 dc.b   "Rb",0,"Rubidium    ",0
 dc.l    854678
 dc.b    4
 dc.b   1,0,0,0
 dc.b    2
 dc.b    42
 dc.b    8
 dc.b    %00000001
 dc.b    %00000000
 dc.w    31204
 dc.w    9612
 dc.b    2
 dc.b    1
 dc.b   "Sr",0,"Strontium   ",0
 dc.l    8762
 dc.b    2
 dc.b   2,0,0,0
 dc.b    3
 dc.b    57
 dc.b    10
 dc.b    %00000010
 dc.b    %00000000
 dc.w    10422
 dc.w    16572
 dc.b    1
 dc.b    1
 dc.b   "Y ",0,"Yttrium     ",0
 dc.l    8890585
 dc.b    5
 dc.b   2,1,0,0
 dc.b    4
 dc.b    64
 dc.b    13
 dc.b    %00000100
 dc.b    %00000000
 dc.w    17962
 dc.w    36102
 dc.b    1
 dc.b    1
 dc.b   "Zr",0,"Zirconium   ",0
 dc.l    91224
 dc.b    3
 dc.b   2,2,0,0
 dc.b    4
 dc.b    68
 dc.b    14
 dc.b    %00001000
 dc.b    %00000000
 dc.w    21252
 dc.w    46502
 dc.b    1
 dc.b    1
 dc.b   "Nb",0,"Niobium     ",0
 dc.l    9290638
 dc.b    5
 dc.b   1,4,0,0
 dc.b    4
 dc.b    69
 dc.b    16
 dc.b    %00010100
 dc.b    %00000000
 dc.w    27412
 dc.w    52002
 dc.b    1
 dc.b    1
 dc.b   "Mo",0,"Molybdene   ",0
 dc.l    9594
 dc.b    2
 dc.b   1,5,0,0
 dc.b    4
 dc.b    71
 dc.b    18
 dc.b    %00100100
 dc.b    %00000000
 dc.w    28902
 dc.w    48852
 dc.b    1
 dc.b    1
 dc.b   "Tc",0,"Technetium  ",0
 dc.l    98
 dc.b    0
 dc.b   2,5,0,0
 dc.b    4
 dc.b    73
 dc.b    19
 dc.b    %01101000
 dc.b    %00000000
 dc.w    24732
 dc.w    51502
 dc.b    1
 dc.b    1
 dc.b   "Ru",0,"Ruthenium   ",0
 dc.l    10107
 dc.b    2
 dc.b   1,7,0,0
 dc.b    4
 dc.b    74
 dc.b    22
 dc.b    %00000100
 dc.b    %00000000
 dc.w    25232
 dc.w    41732
 dc.b    1
 dc.b    1
 dc.b   "Rh",0,"Rhodium     ",0
 dc.l    1029055
 dc.b    4
 dc.b   1,8,0,0
 dc.b    4
 dc.b    75
 dc.b    22
 dc.b    %00000100
 dc.b    %00000000
 dc.w    22392
 dc.w    40002
 dc.b    1
 dc.b    1
 dc.b   "Pd",0,"Palladium   ",0
 dc.l    10642
 dc.b    2
 dc.b   0,10,0,0
 dc.b    4
 dc.b    83
 dc.b    22
 dc.b    %00001010
 dc.b    %00000000
 dc.w    18252
 dc.w    32002
 dc.b    1
 dc.b    1
 dc.b   "Ag",0,"Argent      ",0
 dc.l    1078682
 dc.b    4
 dc.b   1,10,0,0
 dc.b    4
 dc.b    76
 dc.b    19
 dc.b    %00000001
 dc.b    %00000000
 dc.w    12351
 dc.w    24852
 dc.b    1
 dc.b    1
 dc.b   "Cd",0,"Cadmium     ",0
 dc.l    112411
 dc.b    3
 dc.b   2,10,0,0
 dc.b    5
 dc.b    90
 dc.b    17
 dc.b    %00000010
 dc.b    %00000000
 dc.w    59405
 dc.w    10382
 dc.b    2
 dc.b    1
 dc.b   "In",0,"Indium      ",0
 dc.l    114818
 dc.b    3
 dc.b   2,10,1,0
 dc.b    5
 dc.b    58
 dc.b    17
 dc.b    %00000100
 dc.b    %00000000
 dc.w    42976
 dc.w    22732
 dc.b    2
 dc.b    1
 dc.b   "Sn",0,"Etain       ",0
 dc.l    11871
 dc.b    2
 dc.b   2,10,2,0
 dc.b    5
 dc.b    73
 dc.b    18
 dc.b    %00001010
 dc.b    %00000000
 dc.w    50505
 dc.w    25432
 dc.b    2
 dc.b    1
 dc.b   "Sb",0,"Antimoine   ",0
 dc.l    12176
 dc.b    2
 dc.b   2,10,3,0
 dc.b    6
 dc.b    86
 dc.b    19
 dc.b    %00010100
 dc.b    %00000100
 dc.w    9032
 dc.w    20232
 dc.b    1
 dc.b    1
 dc.b   "Te",0,"Tellure     ",0
 dc.l    1276
 dc.b    1
 dc.b   2,10,4,0
 dc.b    6
 dc.b    90
 dc.b    21
 dc.b    %00101000
 dc.b    %00000010
 dc.w    7227
 dc.w    12630
 dc.b    1
 dc.b    2
 dc.b   "I ",0,"Iode        ",0
 dc.l    12690447
 dc.b    5
 dc.b   2,10,5,0
 dc.b    1
 dc.b    105
 dc.b    25
 dc.b    %01010001
 dc.b    %00000001
 dc.w    38665
 dc.w    45715
 dc.b    2
 dc.b    2
 dc.b   "Xe",0,"Xenon       ",0
 dc.l    13129
 dc.b    2
 dc.b   2,10,6,0
 dc.b    7
 dc.b    121
 dc.b    0
 dc.b    %00101010
 dc.b    %00000000
 dc.w    16125
 dc.w    16505
 dc.b    2
 dc.b    2
 dc.b   "Cs",0,"Cesium      ",0
 dc.l    13290546
 dc.b    5
 dc.b   1,0,0,0
 dc.b    2
 dc.b    39
 dc.b    7
 dc.b    %00000001
 dc.b    %00000000
 dc.w    30165
 dc.w    9516
 dc.b    2
 dc.b    1
 dc.b   "Ba",0,"Baryum      ",0
 dc.l    137327
 dc.b    3
 dc.b   2,0,0,0
 dc.b    3
 dc.b    52
 dc.b    9
 dc.b    %00000010
 dc.b    %00000000
 dc.w    9982
 dc.w    14132
 dc.b    1
 dc.b    1
 dc.b   "La",0,"Lanthane    ",0
 dc.l    1389055
 dc.b    4
 dc.b   2,0,1,0
 dc.b    4
 dc.b    56
 dc.b    11
 dc.b    %00000100
 dc.b    %00000000
 dc.w    11932
 dc.w    37302
 dc.b    1
 dc.b    1
 dc.b   "Ce",0,"Cerium      ",0
 dc.l    140116
 dc.b    3
 dc.b   2,1,1,0
 dc.b    4
 dc.b    66
 dc.b    11
 dc.b    %00001100
 dc.b    %00000000
 dc.w    10682
 dc.w    35302
 dc.b    1
 dc.b    1
 dc.b   "Pr",0,"Praseodyme  ",0
 dc.l    14090765
 dc.b    5
 dc.b   2,3,0,0
 dc.b    4
 dc.b    58
 dc.b    11
 dc.b    %00000100
 dc.b    %00000000
 dc.w    12082
 dc.w    34002
 dc.b    1
 dc.b    1
 dc.b   "Nd",0,"Neodyme     ",0
 dc.l    14424
 dc.b    2
 dc.b   2,4,0,0
 dc.b    4
 dc.b    63
 dc.b    0
 dc.b    %00000100
 dc.b    %00000000
 dc.w    12832
 dc.w    34002
 dc.b    1
 dc.b    1
 dc.b   "Pm",0,"Promethium  ",0
 dc.l    145
 dc.b    0
 dc.b   2,5,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000100
 dc.b    %00000000
 dc.w    13532
;The melting point for Pm was taken from
;http://www.chemicool.com/
 dc.w    0
 dc.b    1
 dc.b    0
 dc.b   "Sm",0,"Samarium    ",0
 dc.l    15036
 dc.b    2
 dc.b   2,6,0,0
 dc.b    4
 dc.b    56
 dc.b    12
 dc.b    %00000110
 dc.b    %00000000
 dc.w    13452
 dc.w    21732
 dc.b    1
 dc.b    1
 dc.b   "Eu",0,"Europium    ",0
 dc.l    151964
 dc.b    3
 dc.b   2,7,0,0
 dc.b    4
 dc.b    57
 dc.b    0
 dc.b    %00000110
 dc.b    %00000000
 dc.w    10952
 dc.w    18702
 dc.b    1
 dc.b    1
 dc.b   "Gd",0,"Gadolinium  ",0
 dc.l    15725
 dc.b    2
 dc.b   2,7,1,0
 dc.b    4
 dc.b    62
 dc.b    11
 dc.b    %00000100
 dc.b    %00000000
 dc.w    15842
 dc.w    35062
 dc.b    1
 dc.b    1
 dc.b   "Tb",0,"Terbium     ",0
 dc.l    15892534
 dc.b    5
 dc.b   2,9,0,0
 dc.b    4
 dc.b    67
 dc.b    12
 dc.b    %00000100
 dc.b    %00000000
 dc.w    16332
 dc.w    33142
 dc.b    1
 dc.b    1
 dc.b   "Dy",0,"Dysprosium  ",0
 dc.l    1625
 dc.b    1
 dc.b   2,10,0,0
 dc.b    4
 dc.b    68
 dc.b    0
 dc.b    %00000100
 dc.b    %00000000
 dc.w    16852
 dc.w    28352
 dc.b    1
 dc.b    1
 dc.b   "Ho",0,"Holmium     ",0
 dc.l    16493031
 dc.b    5
 dc.b   2,11,0,0
 dc.b    4
 dc.b    0
 dc.b    12
 dc.b    %00000100
 dc.b    %00000000
 dc.w    17432
 dc.w    29932
 dc.b    1
 dc.b    1
 dc.b   "Er",0,"Erbium      ",0
 dc.l    16726
 dc.b    2
 dc.b   2,12,0,0
 dc.b    4
 dc.b    61
 dc.b    0
 dc.b    %00000100
 dc.b    %00000000
 dc.w    17952
 dc.w    27832
 dc.b    1
 dc.b    1
 dc.b   "Tm",0,"Thulium     ",0
 dc.l    1689342
 dc.b    4
 dc.b   2,13,0,0
 dc.b    4
 dc.b    68
 dc.b    12
 dc.b    %00000100
 dc.b    %00000000
 dc.w    18182
 dc.w    20002
 dc.b    1
 dc.b    1
 dc.b   "Yb",0,"Ytterbium   ",0
 dc.l    17304
 dc.b    2
 dc.b   2,14,0,0
 dc.b    4
 dc.b    63
 dc.b    11
 dc.b    %00000110
 dc.b    %00000000
 dc.w    10972
 dc.w    17392
 dc.b    1
 dc.b    1
 dc.b   "Lu",0,"Lutetium    ",0
 dc.l    174967
 dc.b    3
 dc.b   2,14,1,0
 dc.b    4
 dc.b    62
 dc.b    12
 dc.b    %00000100
 dc.b    %00000000
 dc.w    19292
 dc.w    35882
 dc.b    1
 dc.b    1
 dc.b   "Hf",0,"Hafnium     ",0
 dc.l    17849
 dc.b    2
 dc.b   2,14,2,0
 dc.b    4
 dc.b    70
 dc.b    13
 dc.b    %00001000
 dc.b    %00000000
 dc.w    24232
 dc.w    56732
 dc.b    1
 dc.b    1
 dc.b   "Ta",0,"Tantale     ",0
 dc.l    1809479
 dc.b    4
 dc.b   2,14,3,0
 dc.b    4
 dc.b    79
 dc.b    15
 dc.b    %00010000
 dc.b    %00000000
 dc.w    32692
 dc.w    56982
 dc.b    1
 dc.b    1
 dc.b   "W ",0,"Tungstene   ",0
 dc.l    18384
 dc.b    2
 dc.b   2,14,4,0
 dc.b    4
 dc.b    80
 dc.b    17
 dc.b    %00100000
 dc.b    %00000000
 dc.w    36832
 dc.w    59332
 dc.b    1
 dc.b    1
 dc.b   "Re",0,"Rhenium     ",0
 dc.l    186207
 dc.b    3
 dc.b   2,14,5,0
 dc.b    4
 dc.b    79
 dc.b    19
 dc.b    %01101000
 dc.b    %00000000
 dc.w    34532
 dc.w    59002
 dc.b    1
 dc.b    1
 dc.b   "Os",0,"Osmium      ",0
 dc.l    19023
 dc.b    2
 dc.b   2,14,6,0
 dc.b    4
 dc.b    87
 dc.b    22
 dc.b    %00001100
 dc.b    %00000000
 dc.w    33182
 dc.w    53002
 dc.b    1
 dc.b    1
 dc.b   "Ir",0,"Iridium     ",0
 dc.l    192217
 dc.b    3
 dc.b   2,14,7,0
 dc.b    4
 dc.b    92
 dc.b    22
 dc.b    %00001100
 dc.b    %00000000
 dc.w    26832
 dc.w    48002
 dc.b    1
 dc.b    1
 dc.b   "Pt",0,"Platine     ",0
 dc.l    195078
 dc.b    3
 dc.b   1,14,9,0
 dc.b    4
 dc.b    90
 dc.b    22
 dc.b    %00001010
 dc.b    %00000000
 dc.w    20452
 dc.w    41002
 dc.b    1
 dc.b    1
 dc.b   "Au",0,"Or          ",0
 dc.l    19696655
 dc.b    5
 dc.b   1,14,10,0
 dc.b    4
 dc.b    92
 dc.b    24
 dc.b    %00000101
 dc.b    %00000000
 dc.w    13376
 dc.w    30802
 dc.b    1
 dc.b    1
 dc.b   "Hg",0,"Mercure     ",0
 dc.l    20059
 dc.b    2
 dc.b   2,14,10,0
 dc.b    5
 dc.b    104
 dc.b    19
 dc.b    %00000011
 dc.b    %00000000
 dc.w    23428
 dc.w    62973
 dc.b    2
 dc.b    2
 dc.b   "Tl",0,"Thallium    ",0
 dc.l    2043833
 dc.b    4
 dc.b   2,14,10,1
 dc.b    5
 dc.b    61
 dc.b    18
 dc.b    %00000101
 dc.b    %00000000
 dc.w    57665
 dc.w    17302
 dc.b    2
 dc.b    1
 dc.b   "Pb",0,"Plomb       ",0
 dc.l    2072
 dc.b    1
 dc.b   2,14,10,2
 dc.b    5
 dc.b    74
 dc.b    18
 dc.b    %00001010
 dc.b    %00000000
 dc.w    60065
 dc.w    20132
 dc.b    2
 dc.b    1
 dc.b   "Bi",0,"Bismuth     ",0
 dc.l    20898038
 dc.b    5
 dc.b   2,14,10,3
 dc.b    5
 dc.b    73
 dc.b    19
 dc.b    %00010100
 dc.b    %00000000
 dc.w    54445
 dc.w    18332
 dc.b    2
 dc.b    1
 dc.b   "Po",0,"Polonium    ",0
 dc.l    209
 dc.b    0
 dc.b   2,14,10,4
 dc.b    5
 dc.b    84
 dc.b    20
 dc.b    %00001000
 dc.b    %00000010
 dc.w    52715
 dc.w    12352
 dc.b    2
 dc.b    1
 dc.b   "At",0,"Astate      ",0
 dc.l    210
 dc.b    0
 dc.b   2,14,10,5
 dc.b    6
 dc.b    0
 dc.b    22
 dc.b    %00000000
 dc.b    %00000000
 dc.w    57515
 dc.w    61015
 dc.b    2
 dc.b    2
 dc.b   "Rn",0,"Radon       ",0
 dc.l    222
 dc.b    0
 dc.b   2,14,10,6
 dc.b    7
 dc.b    107
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    20215
 dc.w    21135
 dc.b    2
 dc.b    2
 dc.b   "Fr",0,"Francium    ",0
 dc.l    223
 dc.b    0
 dc.b   1,0,0,0
 dc.b    2
 dc.b    4
 dc.b    7
 dc.b    %00000001
 dc.b    %00000000
 dc.w    30015
 dc.w    9502
 dc.b    2
 dc.b    1
 dc.b   "Ra",0,"Radium      ",0
 dc.l    2260254
 dc.b    4
 dc.b   2,0,0,0
 dc.b    3
 dc.b    53
 dc.b    9
 dc.b    %00000010
 dc.b    %00000000
 dc.w    9732
 dc.w    20102
 dc.b    1
 dc.b    1
 dc.b   "Ac",0,"Actinium    ",0
 dc.l    2270278
;Check this Mass (and all with * by them)
 dc.b    4
 dc.b   2,0,1,0
 dc.b    4
 dc.b    69
 dc.b    11
 dc.b    %00000100
 dc.b    %00000000
 dc.w    13232
 dc.w    34732
 dc.b    1
 dc.b    1
 dc.b   "Th",0,"Thorium     ",0
 dc.l    2320381
 dc.b    4
 dc.b   2,0,2,0
 dc.b    4
 dc.b    70
 dc.b    13
 dc.b    %00001000
 dc.b    %00000000
 dc.w    20232
 dc.w    50632
 dc.b    1
 dc.b    1
 dc.b   "Pa",0,"Protactinium",0
 dc.l    23103587
 dc.b    5
 dc.b   2,2,1,0
 dc.b    4
 dc.b    0
 dc.b    15
 dc.b    %00011000
 dc.b    %00000000
 dc.w    18732
 dc.w   0    
 dc.b    1
 dc.b    0
 dc.b   "U ",0,"Uranium     ",0
 dc.l    2380289
 dc.b    4
 dc.b   2,3,1,0
 dc.b    4
 dc.b    61
 dc.b    17
 dc.b    %00111100
 dc.b    %00000000
 dc.w    14052
 dc.w    40912
 dc.b    1
 dc.b    1
 dc.b   "Np",0,"Neptunium   ",0
;*
 dc.l    237048
 dc.b    3
 dc.b   2,4,1,0
 dc.b    4
 dc.b    0
 dc.b    13
 dc.b    %00111100
 dc.b    %00000000
 dc.w    9132
 dc.w    41752    
 dc.b    1
 dc.b    1
 dc.b   "Pu",0,"Plutonium   ",0
;*
 dc.l    244
 dc.b    0
 dc.b   2,6,0,0
 dc.b    4
 dc.b    58
 dc.b    13
 dc.b    %00111100
 dc.b    %00000000
 dc.w    9127
 dc.w    35082    
 dc.b    1
 dc.b    1
 dc.b   "Am",0,"Americium   ",0
;*
 dc.l    243
 dc.b    0
 dc.b   2,7,0,0
 dc.b    4
 dc.b    0
 dc.b    13
 dc.b    %00111100
 dc.b    %00000000
 dc.w    12672
 dc.w 28802
 dc.b    1
 dc.b    1
 dc.b   "Cm",0,"Curium      ",0
 dc.l    247
 dc.b    0
 dc.b   2,7,1,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000100
 dc.b    %00000000
 dc.w    16132
 dc.w   0    
 dc.b    2
 dc.b    0
 dc.b   "Bk",0,"Berkelium   ",0
 dc.l    247
 dc.b    0
 dc.b   2,9,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00001100
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Cf",0,"Californium ",0
 dc.l    251
 dc.b    0
 dc.b   2,10,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000100
 dc.b    %00000000
 dc.w    900
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Es",0,"Einsteinium ",0
 dc.l    252
 dc.b    0
 dc.b   2,11,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Fm",0,"Fermium     ",0
 dc.l    257
 dc.b    0
 dc.b   2,12,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Md",0,"Mendelevium ",0
 dc.l    258
 dc.b    0
 dc.b   2,13,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "No",0,"Nobelium    ",0
 dc.l    259
 dc.b    0
 dc.b   2,14,0,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Lr",0,"Lawrencium  ",0
 dc.l    262
 dc.b    0
 dc.b   2,14,0,1
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Uq",0,"Unnilquadium",0
 dc.l    261
 dc.b    0
 dc.b   2,14,2,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Up",0,"Unnilpentium",0
 dc.l    262
 dc.b    0
 dc.b   2,14,3,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Uh",0,"Unnilhexium ",0
 dc.l    263
 dc.b    0
 dc.b   2,14,4,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Us",0,"Unnilseptium",0
 dc.l    262
 dc.b    0
 dc.b   2,14,5,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Uo",0,"Unniloctium ",0
 dc.l    265
 dc.b    0
 dc.b   2,14,6,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w   0    
 dc.b    0
 dc.b    0
 dc.b   "Ue",0,"Unnilennium",0
 dc.l    266
 dc.b    0
 dc.b   2,14,7,0
 dc.b    4
 dc.b    0
 dc.b    0
 dc.b    %00000000
 dc.b    %00000000
 dc.w    0
 dc.w    0    
 dc.b    0
 dc.b    0
 dc.b   "  ",0,"            ",0



;** Menus **
 even
Menu1Shortcuts
 dc.b    0,0,0,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3    ;a-z (28 bytes)
Menu2Shortcuts
 dc.b    0,9,15,26,27,31,35,38,42,45,45,46,50,55,61,64,74,74,80,87,96,103,104,104,105,107,1 a-z (28 bytes)
Menu2Sort
 dc.b    89,13,95,51,47,18,33,85,7,56,97,4,83,5,35,48,20,98,6,58 
 dc.b    55,17,24,27,29,96,66,99,68,50,63,26,100,9,87,64,31,32,72
 dc.b    2,67,1,49,53,77,36,57,103,3,71,12,25,101,80,42,60,10,93,28
 dc.b    41,102,79,76,8,46,15,78,82,94,84,19,59,61,91,88,86,75,45,37,44
 dc.b    62,21,34,14,11,16,38,73,43,52,65,81,90,69,22,74,109,106,108,105,104,107,92,23,54,70,39,30,40,110
Menu3Shortcuts
 dc.b    0,8,14,25,26,29,33,36,41,41,44,46,50,54,62,64,73,73,79,87,95,102,103,104,105,107,1 a-z (28 bytes)
Menu3Sort
 dc.b    89,47,13,95,18,33,85,79,5,56,4,83,97,35,6,20,48,58,98
 dc.b    17,96,27,24,55,29
 dc.b    66,68,99,63,9,26,100,87,31,64,32,1,2,72,80,67,53,49,77,19,36
 dc.b    57,3,103,71,101,12,25,42,7,11,41,60,10,28,102,93,8,76
 dc.b    15,91,82,46,61,84,59,78,94,88,37,75,45,86,44,16,51,21,34,62,50,14,38,73,52,65,43
 dc.b    90,22,81,69,92,109,106,108,105,104,107,23,74,54,39,70,30,40,110
Menu1
 dc.b    4                         ;Numof Items
 dc.b    "    Periodfr : menu",0    ;title=20 bytes
 dc.b    13                        ;width of entries
 dc.b    "Cherche noms",0,
 dc.b    "Cherche symb",0,
 dc.b    "Menus:Moyen ",0,
 dc.b    "Quitter     ",0,
 dc.b    "            ",0        ;always end with blank
Menu3Title
 dc.b    "Recherche par symb.",0
Menu2Title
 dc.b    "Recherche par noms ",0

MassStr    dc.b    "Masse:",0
IonizeStr    dc.b    "Ion.E. (eV):",0    
ElectroStr    dc.b    "El.neg.:",0
MeltingStr    dc.b    "Fusion(K):",0
BoilingStr    dc.b    "Ebull.(K):",0
NotAvail
 dc.b    "Inconnu",0
EL_Bases
 dc.b "[He][Ne][Ar][Kr][Xe][Rn]"
EL_Levels
 dc.b "1s      "
 dc.b "2s2p    "
 dc.b "3s3p    "
 dc.b "4s3d4p  "
 dc.b "5s4d5p  "
 dc.b "6s4f5d6p"
 dc.b "7s5f6d7p"
ETypes:
 dc.b    "Non-metal            ",0  ; 22 bytes
 dc.b    "Metal alcali         ",0
 dc.b    "Metal alcalin terre  ",0
 dc.b    "Element de transition",0
 dc.b    "Autre metal          ",0
 dc.b    "Semi-metal           ",0
 dc.b    "Gaz noble            ",0
tmpstring dc.b "          ",0 ;maximum 10 char string
LookUpTable        ;
 dc.b 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
 dc.b 3,4,0,0,0,0,0,0,0,0,0,0,5,6,7,8,9,10
 dc.b 11,12,0,0,0,0,0,0,0,0,0,0,13,14,15,16,17,18
 dc.b 19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36
 dc.b 37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54
 dc.b 55,56,57,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86
 dc.b 87,88,89,104,105,106,107,108,109,0,0,0,0,0,0,0,0,0
 dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.b 0,0,0,0,58,59,60,61,62,63,64,65,66,67,68,69,70,71
 dc.b 0,0,0,0,90,91,92,93,94,95,96,97,98,99,100,101,102,103
title_text dc.b "-- Classification Periodique --   APPS : menu",0
_comment dc.b "Classification priodique par WJ",0
Slow
 dc.b    "Lent  "
Medium
 dc.b    "Moyen "
Fast
 dc.b    "Rapide"
                         









PressAKeyStr dc.b "-- Presser esc --",0

;descr dc.b "     -- Classification Priodique by WJ --     ",0

 end
