;Equates for Period89
;File written by Paul Aurich


;********** Assembling for 89 and 92+ **********;
;To assemble for the 89, make sure that ONLY the;
;xdef _ti89 line (not the xdef _ti92plus) is	;
;uncommented. Then, skip to the section under	;
;the Key Equates heading and read directions	;
;there about the equates. To assemble for the	;
;92+, uncomment the xdef _ti92plus line and	;
;comment the xdef _ti89 line. Then skip to Key	;
;Equates section.				;
;***********************************************;

 xdef _ti89
; xdef _ti92plus


;***************** Key Equates *****************;
;These key equates are used because the TI-89 &	;
;TI-92 Plus have different Diamond Key equates	;
;These make it so that all the keys work	;
;work correctly on either calculator. To	;
;assemble for the TI-89, make sure that the 89	;
;key codes are uncommented (first group of EQUs);
;To assemble for the 92+, comment those out and ;
;uncomment the second group.			;
;***********************************************;

;TI-89 Key Codes
diamondUp		EQU		16721
diamondRight		EQU		16728
diamondLeft		EQU		16722
diamondDown		EQU		16724
downKey			EQU		340
upKey			EQU		337
leftKey			EQU		338
rightKey			EQU		344

;TI-92 Plus Key Codes
;diamondUp		EQU		8530
;diamondRight		EQU		8532
;diamondLeft		EQU		8536
;diamondDown		EQU		8529
;downKey			EQU		344
;upKey			EQU		338
;leftKey			EQU		337
;rightKey			EQU		340

;Misc. Key Codes
enterKey		EQU		13
escKey			EQU		264
appsKey			EQU		265


;**************** Data Offsets *****************;
;These are the offsets for the Periodic Table	;
;data. If you ever change the placement of a	;
;particular piece of data in the data table,	;
;You should adjust the value here accordingly.	;
;If you do that, you should take care of almost ;
;all problems with changing the data order.	;
;***********************************************;
DataOffset		EQU		36			;The offset between two elements in the data
elementsym		EQU		0			;The offset IN an elemental data to the symbol
elementname		EQU		3			;Offset to the name
mass			EQU		16			;Offset to mass
electronconfig		EQU		21			;Offset to electronconfig
elementtype		EQU		25			;Offset to type of element
ionenergy		EQU		26			;Offset to ionic energy
electroneg		EQU		27			;Offset to electroneg
posoxidation		EQU		28			;Offset to positive oxidation states
negoxidation		EQU		29			;Offset to negative oxidation states
melting			EQU		30			;Offset to melting point (in Kelvin)
boiling			EQU		32			;Offset to boiling point (in Kelvin)
meltingcomma		EQU		34			;Offset to melting point comma position
boilingcomma		EQU		35			;Offset to boiling point comma position
;density			EQU		36			;Offset to density (in g/cm3)
;densitycomma		EQU		38			;Offset to density comma position
